Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0004533opensim[REGION] Physics Enginespublic2010-01-21 12:012019-02-12 14:07
ReporterMisterblue 
Assigned To 
PrioritynormalSeverityminorReproducibilityalways
StatusconfirmedResolutionopen 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target VersionFixed in Version 
Summary0004533: Physical balls do not pile correctly
DescriptionIf one drops physical balls into a pile from the same location, the balls do not pile into a messy pile but pile in a single line. Attached is a picture showing multiple sets of physical balls dropped onto a slanted surface, rolling down to form piles at the bottom of the surface and forming piles that are lined up with no piling other than the direction of movement. The piles in the pictures were generated with dropper that periodically creates a new physical ball at exactly the same location and letting that ball fall onto the slanted surface.

Once any of the balls have any sideways motion (like giving a manual push) the balls will start piling more real world-like.
Additional InformationMore pictures:
http://files.misterblue.com/opensim/physics/20100119_001.jpg [^]
http://files.misterblue.com/opensim/physics/20100119_002.jpg [^]
http://files.misterblue.com/opensim/physics/20100121_001.jpg [^]
http://files.misterblue.com/opensim/physics/20100121_004.jpg [^]
TagsNo tags attached.
Git Revision or version number243cd0c00d7dc9b2049dcad3f74d9082c95ce294
Run ModeStandalone (1 Region)
Physics EngineODE
Environment.NET / Windows32
Mono VersionNone
Viewer
Attached Filesjpg file icon 20100119_008.jpg [^] (74,643 bytes) 2010-01-21 12:01

- Relationships

-  Notes
(0034689)
tampa (reporter)
2019-02-09 20:27

This is hilarious, but unfortunately still a thing in both Bullet and ubODE.
(0034693)
BillBlight (developer)
2019-02-09 20:40

Actually I'm not sure this is actually an issue, if for instance in the real world you could remove all outside influence, set a specific gravity , exact density, and level of bounce for a ball, they would also stack like this, if lined up EXACTLY.

The issue is because of the stock parameters a sphere is rezzed with, if you change them via a script as rezzed the balls will not all behave exactly the same.
(0034728)
tampa (reporter)
2019-02-11 09:37

Question is what is the intended behavior though or what does one expect. Possibly how does SL physics behave in that regard? I certainly feel like this is not something I would expect to see, but that's just me.
(0034729)
UbitUmarov (administrator)
2019-02-11 12:17

yes this will happen, eventually little instabilies may make them fall
I also remember a cube totally balanced on one corner, even staying that way pushed by a avatar, if friction was set to zero.
(0034731)
Total Sorbet (reporter)
2019-02-12 11:54

This is nice! Identical prim dropped from same pos with same characteristics.. is exactly what i would expect. Sometimes predictability is a good thing.. In rl there is always some varying factor such as friction, wind or some other noise in the system. This consistency allows scripts the freedom to control from a non-random position which i consider a good thing.
(0034732)
BillBlight (developer)
2019-02-12 11:56

@Total Sorbet, I totally agree, if there was randomness by default, precise physics scripting would be impossible ...
(0034733)
tampa (reporter)
2019-02-12 12:08

Precise physics scripting is already not going to produce exact results due to various factors like SimFPS and so on. I tried making a physical waterslide, but there was almost no way to predict the behavior of the inner tube going down the tubes. I would not go as far to say that the physics engines are capable of reproducing exact same results each time they are in use and to me this feels like a glitch in the matrix. Hence why I said, maybe if the desire is to retain predictable physics make it a configurable option and add the expected randomness based on it.
(0034734)
Total Sorbet (reporter)
2019-02-12 12:30

@tampa give me a clean canvas.. let it follow simple predictable rules and give me the power to influence that.
(0034735)
Robert Adams (administrator)
2019-02-12 12:30

Whoa! This is a bug I filed nearly a decade ago against the old ODE. Probably before I worked on BulletSim.

I tried to build a test to duplicate this but I wasn't able to reproduce it. Do you (Tampa) have a test that reproduces this problem?
(0034736)
tampa (reporter)
2019-02-12 13:06

I tried this on Bullet and ubODE, both seemed to replicate that piling up using a similar rig as shown in your pictures.
(0034737)
paela argus (reporter)
2019-02-12 13:15
edited on: 2019-02-12 13:22

I'm boring but I join Misterblue and Adam, a perfect alignment of the physical prims in a fall is not at all realistic, the physics must follow the wind of the sim, the inclination of the ground and the impact with another object, to make it anarchic in its direction ( random ), When to make the physics control through a script it is quite possible even if the simulator manages its in random direction, it is enough to attribute in the code that the script will have priority on the physical default if present.

(0034738)
BillBlight (developer)
2019-02-12 13:26

@paela , make them more bouncy than default as they rez they will bounce random
(0034739)
paela argus (reporter)
2019-02-12 13:42

When I make a round of prims rounds from the sky I notice that they stay in a fairly compact pit instead of leaving, it does not bounce, whereas in opensim the ground is not movable with the impact of a falling object it should bounce according to its own fall speed, the distance in the moment 'Inpact should do it "rehearse" on a speed calculation that the prims should take in its fall, if it's low on the rules of real physics. But I do not know a lots of people who have fun falling objects from the sky just to have fun
(0034740)
BillBlight (developer)
2019-02-12 13:57

The issue with that is the settings for Bounciness on the prim itself, the default settings are to NOT bounce that much at all, if you increase that, via a script on rez, things will bounce all over the place ...
(0034741)
UbitUmarov (administrator)
2019-02-12 13:58

I don't see any bug on this.
I fact good to see physics math holding, keeping a pure unstable equilibrium for several iterations.

just add a bit of small random values on rez position to get more realistic thing.

it is not physics engine job to do that, what you think is realistic is not on other conditions.
(0034742)
Total Sorbet (reporter)
2019-02-12 14:07

exactly :) this is a triumph of physics engine maths! something to be applauded and then abused via script for our own advantage whatever that might be!!

- Issue History
Date Modified Username Field Change
2010-01-21 12:01 Misterblue New Issue
2010-01-21 12:01 Misterblue File Added: 20100119_008.jpg
2010-01-21 12:01 Misterblue Git Revision => 243cd0c00d7dc9b2049dcad3f74d9082c95ce294
2010-01-21 12:01 Misterblue SVN Revision => 0
2010-01-21 12:01 Misterblue Run Mode => Standalone (1 Region)
2010-01-21 12:01 Misterblue Physics Engine => ODE
2010-01-21 12:01 Misterblue Environment => .NET / Windows32
2010-01-21 12:01 Misterblue Mono Version => None
2019-02-09 20:27 tampa Note Added: 0034689
2019-02-09 20:27 tampa Status new => confirmed
2019-02-09 20:40 BillBlight Note Added: 0034693
2019-02-11 09:37 tampa Note Added: 0034728
2019-02-11 12:17 UbitUmarov Note Added: 0034729
2019-02-12 11:54 Total Sorbet Note Added: 0034731
2019-02-12 11:56 BillBlight Note Added: 0034732
2019-02-12 12:08 tampa Note Added: 0034733
2019-02-12 12:30 Total Sorbet Note Added: 0034734
2019-02-12 12:30 Robert Adams Note Added: 0034735
2019-02-12 13:06 tampa Note Added: 0034736
2019-02-12 13:15 paela argus Note Added: 0034737
2019-02-12 13:16 paela argus Note Edited: 0034737 View Revisions
2019-02-12 13:16 paela argus Note Edited: 0034737 View Revisions
2019-02-12 13:22 paela argus Note Edited: 0034737 View Revisions
2019-02-12 13:26 BillBlight Note Added: 0034738
2019-02-12 13:42 paela argus Note Added: 0034739
2019-02-12 13:57 BillBlight Note Added: 0034740
2019-02-12 13:58 UbitUmarov Note Added: 0034741
2019-02-12 14:07 Total Sorbet Note Added: 0034742


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker